
; ========================================================
;			
;    Combination of    TCPTest.asm -- Jay Sullivan
;    and routines from  sync_3.asm -- six_L
;
;    New code :
;    Parse the HEAD request for the date time stamp, 
;    apply the offset to GMT (-4), set the system time.
;
;    Load IP, Connect, Send, Disconnect
;
;    GMToffset   holds the hour offset from GMT
;    -4 is the current value, it is behind GMT 
;    it would be a positive value if ahead of GMT
;
; ========================================================
  

.686
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;------------------------------------------------
;               Header
;------------------------------------------------

;#################################################
;#                Macro
;#################################################



	$String MACRO sTEXT
		LOCAL szText
		.data
		 szText db sTEXT, 0
		.code
		EXITM <Offset szText>
	ENDM
	
	
  
;#################################################
;#                Include
;#################################################
	include \masm32\include\windows.inc
	include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	include \masm32\include\wsock32.inc
	include \masm32\include\comctl32.inc
      include \masm32\include\advapi32.inc
	;-------------------------------------------------------------------
	;Needed For Debug Window Only
	;include masm32.inc
	;include debug.inc
	;includeLib masm32.lib
	;includeLib debug.lib
	;-------------------------------------------------------------------
	includeLib \masm32\lib\user32.lib
	includeLib \masm32\lib\kernel32.lib
	includelib \masm32\lib\wsock32.lib
	includelib \masm32\lib\comctl32.lib
      includelib \masm32\lib\advapi32.lib

;#################################################
;#                .DATA
;#################################################
.data
      szName                  db "SE_SYSTEMTIME_NAME",0,0
	ClassName		      db "MainWinClass",0
	szAppName		      db "HttpSync",0
	szCButton	 	      db "BUTTON",0
	szCEdit			db "EDIT",0
      szTimeSet               db "Time Set",0

align 16
      aSysTime  SYSTEMTIME <>
      bSysTime  SYSTEMTIME <>
      cSysTime  SYSTEMTIME <>
      dSysTime  SYSTEMTIME <>

      szFNameOut              db "web.bin",0

      afilTime  FILETIME   <>
      bfilTime  FILETIME   <>
      cfilTime  FILETIME   <>
      dfilTime  FILETIME   <>

      hFileOut                dd 0
      bWritten                dd 0
      filelen                 dd 0
      GMToffset               dd -4
      loGMToffset             dd 0
      hiGMToffset             dd 0

	szFuncSocket		db "socket()       ",0
	szFuncConnect		db "connect()      ",0
	szFuncRecv			db "recv()         ",0
	szFuncSend			db "send()         ",0
	szFuncBind			db "bind()         ",0
	szFuncInet_addr		db "inet_addr()    ",0
	szFuncGethostbyname	db "gethostbyname()",0
	StatusWidths            dd 100,200,500,600,700
	 
	wsaData         WSADATA <>
 	peer        sockaddr_in <AF_INET, 080h, <>, 8 dup(0)>
 	ptrIP           hostent <>
 	ptrIPName            dd ?
 	
 	sendString        db "HEAD /timezone.cgi?Eastern/d/-5 HTTP/1.1",13,10 ; "HEAD / HTTP/1.1",13,10
				db "Host: www.time.gov",13,10                       ; "Host: www.yahoo.com",13,10
				db "Connection: close",13,10
				db 13,10
  	sendStringLength equ $ - Offset sendString
				db 0
  	recvStringLength equ 4*4096
  	
  	pBufferIPAddress  db "time.gov", 24 dup(0)  ; "www.yahoo.com"  '209.73.186.238', 16 dup (0) "129.6.13.32"
  	
  	IDT_TIMER1    dd 5
  	szDots	  db '.........................',0
  	szDotLen      dd 0
  	
align 16
      szBuffer      db 4*4096 dup (?)
	hInstance		 HINSTANCE ?
	CommandLine		 LPSTR     ?
	hHeap	             HANDLE    ?

	ThreadID	           DWORD ?
	
	hWin				HWND ?
	myButtonConnect		HWND ?
	myButtonDisconnect	HWND ?
	myButtonSend		HWND ?
	myButtonDNS			HWND ?
	hEditOutput			HWND ?
	hEditMyText			HWND ?
	hEditIPAddress		HWND ?
	hStatusBar			HWND ?

	s		          SOCKET ?
	
	myHostName       db 64 dup(?)
	myHostIP         dd ?
	hListeningThread dd ?
	hConnectThread   dd ?
	hostEntry        dd ?
	
	pBufferMyText    dd ?
	pBufferOutput    dd ?
	pBufferLoc	     dd ?
      pBuffer          dd ?
	
	MessageSize      dd ?


align 16
OSVINFO STRUCT
	dwOSVersionInfoSize   DWORD      ?
	dwMajorVersion        DWORD      ?
	dwMinorVersion        DWORD      ?
	dwBuildNumber         DWORD      ?
	dwPlatformId          DWORD      ?
	szCSDVersion          BYTE 128 dup (?)
OSVINFO ENDS
;---------------------------------------------
LUIDCUST STRUCT
	usedpart              DWORD      ?
	ignorehigh32bitpart   DWORD      ?
LUIDCUST ENDS
;---------------------------------------------
TOKEN_PRIVS STRUCT
	privilegecount        DWORD      ?
	theluid               LUIDCUST   <>
	attributes            DWORD      ?
TOKEN_PRIVS ENDS

;#################################################
;#                EQU
;#################################################
	IDM_FILE_NEW	EQU 1
	IDM_FILE_OPEN	EQU 2
	IDM_HELP_ABOUT	EQU 3
	IDM_FILE_EXIT	EQU 4
		
	;----------------------------
	;     Prototypes
	;----------------------------
		
	WinMain          PROTO :DWORD,:DWORD,:DWORD,:DWORD
	szCopyx          PROTO src:DWORD,dst:DWORD,siz:DWORD
	SendDataThread   PROTO
	ConnectIPThread  PROTO
	GetHostDNSThread PROTO
      IsWinNt          PROTO
      AdjustToken      PROTO :DWORD
      SetTime          PROTO :DWORD

;------------------------------------------------
;                .CODE
;------------------------------------------------

.code

    Start:
		invoke GetModuleHandle, NULL
		mov    hInstance,eax
		invoke GetProcessHeap
		mov    hHeap, eax
		invoke GetCommandLine
		mov    CommandLine, eax

            mov ecx, GMToffset
            .if ecx > 23
               neg ecx
            .endif

            mov ecx, ecx          ; 4 hours for GMT offset
            xor eax, eax          ; four hours   one hour
            xor edx, edx          ; 144 billion  36 billion
       L0:
            add eax, 61C46800h    ; four hours   one hour
            adc edx, 8            ; 144 billion  36 billion
            dec ecx
            jnz L0

            .if GMToffset > 23
               sub eax,  5000000     ; 10 million == 1 second      ; if +GMT  add
               sbb edx, 0            ;                             ; if +GMT  adc
            .else
               add eax,  5000000     ; 10 million == 1 second      ; if +GMT  add
               adc edx, 0            ;                             ; if +GMT  adc
            .endif

            mov loGMToffset, eax
            mov hiGMToffset, edx
            
		invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		

;------------------------------------------------
;	WinMain
;------------------------------------------------
WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND

		;-------------------------------------------
		; HeapAlloc() - Make space for incoming data
		;-------------------------------------------
		
			invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY, recvStringLength
			mov pBufferOutput, eax
			invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY, 4*4096
			mov pBufferMyText, eax
                  mov pBuffer, offset szBuffer
	;------------------------------------------------
	;	Windows
	;------------------------------------------------
			
		;------------------------------------------------
		;	Main Window Register
		;------------------------------------------------
		
			mov wc.cbSize, Sizeof WNDCLASSEX
			mov wc.style, CS_HREDRAW or CS_VREDRAW
			mov wc.lpfnWndProc, Offset WndProc
			mov wc.cbClsExtra,NULL
			mov wc.cbWndExtra,NULL
			mov eax,hInst
			mov wc.hInstance,eax
			mov wc.hbrBackground, COLOR_WINDOW+1
			mov wc.lpszMenuName, NULL
			mov wc.lpszClassName, Offset ClassName
			invoke LoadIcon, NULL, IDI_APPLICATION
			mov wc.hIcon,eax
			mov wc.hIconSm,0
			invoke LoadCursor, NULL, IDC_ARROW
			mov wc.hCursor,eax
			invoke RegisterClassEx, ADDR wc
		
		
		;------------------------------------------------
		;	Main Window Create
		;------------------------------------------------
		
				
			invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR szAppName,\
				WS_OVERLAPPEDWINDOW,\
				CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,\
				NULL,NULL,hInst,NULL
			mov hwnd,eax
			mov hWin, eax
		
		;------------------------------------------------
		;	buttons/edits
		;------------------------------------------------

			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("Connect"),    WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT or WS_DISABLED ,0,15,75,35,hwnd,0,hInst,0
			mov myButtonConnect,eax
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("Send"),       WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT or WS_DISABLED ,75,15,75,35,hwnd,0,hInst,0
			mov myButtonSend,eax
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("Disconnect"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT or WS_DISABLED ,150,15,100,35,hwnd,0,hInst,0
			mov myButtonDisconnect,eax
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("Load IP#"),   WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,410,15,100,35,hwnd,0,hInst,0
			mov myButtonDNS,eax
		
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCEdit,0, WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT or ES_NOHIDESEL,510,20,150,25,hwnd,0,hInst,0
			mov hEditIPAddress,eax
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCEdit, Offset sendString, WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT or ES_MULTILINE or ES_NOHIDESEL or ES_AUTOVSCROLL or ES_WANTRETURN or WS_VSCROLL or WS_HSCROLL,15,55,300,500,hwnd,0,hInst,0
			mov hEditMyText,eax
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCEdit,0, WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT or ES_MULTILINE or ES_NOHIDESEL or ES_AUTOVSCROLL or ES_WANTRETURN or WS_VSCROLL or WS_HSCROLL,15,55,300,500,hwnd,0,hInst,0
			mov hEditOutput,eax
			;invoke SendMessage, eax, EM_SETHANDLE, pBufferOutput,0
			
			invoke CreateStatusWindow,WS_CHILD or WS_VISIBLE or SBS_SIZEGRIP , 0, hwnd, 444
			mov hStatusBar,eax
			invoke SendMessage,eax,SB_SETPARTS, 4, Offset StatusWidths
			
		;------------------------------------------------
		;	Get IP address
		;------------------------------------------------

			invoke SetWindowText, hEditIPAddress, Offset pBufferIPAddress
			
	;------------------------------------------------
	;	WinMain Code
	;------------------------------------------------
			
		
			
		;-----------------------------
		;	Show Window
		;-----------------------------
			
			invoke ShowWindow, hwnd, SW_SHOWNORMAL 
			invoke UpdateWindow, hwnd
			
		;-----------------------------
		;	Message Loop
		;-----------------------------
			
			jmp @F
			StartLoop:
			  invoke TranslateMessage,ADDR msg
			  invoke DispatchMessage, ADDR msg
			@@:
			  invoke GetMessage,ADDR msg,NULL,0,0
			  test eax, eax
			  jnz StartLoop
			
	mov eax, msg.wParam
	ret
WinMain ENDP


;------------------------------------------------
;	WndProc
;------------------------------------------------
WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM


	;-----------------------------
	 .if uMsg==WM_DESTROY
	;-----------------------------

		invoke WSACleanup
		invoke PostQuitMessage, NULL
		
	;-----------------------------
	 .elseif uMsg==WM_TIMER
	;-----------------------------
	 	add szDotLen, 1
	 	and szDotLen, 01111b
	 	
	 	mov eax, szDotLen
	 	mov byte ptr szDots[eax], 0
		invoke SendMessage,hStatusBar, SB_SETTEXT, 3,  Offset szDots
	 	mov eax, szDotLen
	 	mov byte ptr szDots[eax], '.'
	;-----------------------------
	 .elseif uMsg==WM_SIZE
	;-----------------------------
	
		movzx eax, word ptr lParam   ; << width
		movzx ecx, word ptr lParam+2 ; << height
		sub ecx, 55+21
		shr eax, 1
		push eax
		push ecx
		invoke MoveWindow, hEditMyText, 0,55, eax, ecx, TRUE
		pop ecx
		pop eax
		invoke MoveWindow, hEditOutput, eax,55, eax, ecx, TRUE
		
		
	  	invoke MoveWindow,hStatusBar,0,0,0,0,TRUE
	;-----------------------------
	 .elseif uMsg==WM_CREATE
	;-----------------------------
		
	;------------------------------------------------
	;	Winsock
	;------------------------------------------------
			
		
		;-------------------------------------------
		; WSAStartup() -- Initialize WinSock
		;-------------------------------------------
			invoke WSAStartup,0101h, Offset wsaData
			
		;-------------------------------------------
		; htons() - Set port number
		;-------------------------------------------
			invoke htons,80
			mov peer.sockaddr_in.sin_port, ax

		;-------------------------------------------
		; inet_addr() - Set IP address
		;-------------------------------------------
			
			invoke inet_addr, Offset pBufferIPAddress
			mov peer.sockaddr_in.sin_addr , eax
					
	
		
		
		;-------------------------------------------
		; WSACleanup() - Done
		;-------------------------------------------
		
		jmp @F
		FailTCP:
			invoke WSACleanup
			mov eax, 1
			ret
		@@:
	;-----------------------------
	 .elseif uMsg==WM_COMMAND
	;-----------------------------
		
		mov eax,wParam
		;-----------------------------
		 .if ax== BN_CLICKED
		;-----------------------------
		
			mov szDotLen, 0
			mov eax, lParam
			;-----------------------------
			.if eax==myButtonConnect
			;-----------------------------
			
			invoke SetTimer, hWnd, IDT_TIMER1, 300, 0
				invoke EnableWindow, myButtonConnect, FALSE
				invoke EnableWindow, myButtonSend, TRUE
				invoke EnableWindow, myButtonDisconnect, TRUE
				
				invoke CreateThread,0,0, Offset ConnectIPThread, 0, 0,0
					
			;-----------------------------
			.elseif eax==myButtonDNS
			;-----------------------------
			invoke SetTimer, hWnd, IDT_TIMER1, 300, 0
				invoke EnableWindow, myButtonConnect, TRUE
				invoke EnableWindow, myButtonSend, FALSE
				invoke EnableWindow, myButtonDisconnect, FALSE
				
				invoke CreateThread,0,0, Offset GetHostDNSThread, 0, 0,0
					
			;-----------------------------
			.elseif eax==myButtonSend
			;-----------------------------
			invoke SetTimer, hWnd, IDT_TIMER1, 300, 0
				invoke EnableWindow, myButtonSend, FALSE
				; invoke EnableWindow, myButtonDisconnect, FALSE  ; added

                        mov cSysTime.wYear, 0

				invoke CreateThread,0,0, Offset SendDataThread, 0, 0,0
                        invoke SetThreadPriority,eax,THREAD_PRIORITY_NORMAL     ; added these two lines
                        invoke CloseHandle,eax


			;-----------------------------
			.elseif eax==myButtonDisconnect
			;-----------------------------
				invoke KillTimer, hWnd, IDT_TIMER1
				
				invoke closesocket, s

                        ;-----------------------
                        ; Set clock now
                        ;-----------------------
                        invoke CreateThread,NULL,NULL,offset SetTime,offset cSysTime,\
                                            IDLE_PRIORITY_CLASS,ADDR ThreadID
                        invoke SetThreadPriority,eax,THREAD_PRIORITY_NORMAL
                        invoke CloseHandle,eax

                        ;.if cSysTime.wYear != 0
                        ;.endif

				invoke EnableWindow, myButtonConnect, TRUE
				invoke EnableWindow, myButtonSend, FALSE
				invoke EnableWindow, myButtonDisconnect, FALSE
			;-----------------------------
			.endif
			;-----------------------------
		;-----------------------------
		 .endif
		;-----------------------------
		
	;-----------------------------
	 .else
	;-----------------------------
		
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
		
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
WndProc ENDP


;------------------------------------------------
;	Get IP address
;------------------------------------------------
GetHostDNSThread PROC

				;------------------------------------------------
				; Clear status bar
				;------------------------------------------------
				invoke SendMessage,hStatusBar, SB_SETTEXT, 1,  0
				invoke SendMessage,hStatusBar, SB_SETTEXT, 2,  0
				
				;------------------------------------------------
				; Attempt to translate IP string to number
				;------------------------------------------------
				invoke GetWindowText, hEditIPAddress, Offset pBufferIPAddress, 16
				invoke inet_addr, Offset pBufferIPAddress
				
				;------------------------------------------------
				.if eax==INADDR_NONE
				;------------------------------------------------
				
				;------------------------------------------------
				; Domain Name is typed in
				;------------------------------------------------
				
					;------------------------------------------------
					; Call up DNS, and make sure it worked
					;------------------------------------------------
					invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("gethostbyname()")
					invoke gethostbyname, Offset pBufferIPAddress
					test eax,eax
					jz @F

					;------------------------------------------------
					; Get Fully Qualified Domain Name
					;------------------------------------------------
					mov ecx, [eax].hostent.h_name
					mov ptrIPName, ecx
					
					;------------------------------------------------
					; Get # IP Address
					;------------------------------------------------
					mov eax, [eax].hostent.h_list ; hostent.h_addr_list
					mov eax, [eax]  ;   *hostent.h_addr_list
					mov eax, [eax]  ;  **hostent.h_addr_list
					mov peer.sockaddr_in.sin_addr, eax
					
					;------------------------------------------------
					; Convert to a string
					;------------------------------------------------
					invoke inet_ntoa, eax
					
					
				;------------------------------------------------
				.else
				;------------------------------------------------
				
				;------------------------------------------------
				; Domain is typed in
				;------------------------------------------------
					
					;------------------------------------------------
					; Call up DNS, and make sure it worked
					;------------------------------------------------
					mov dword ptr ptrIP, eax
					invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("gethostbyaddr()")
					invoke gethostbyaddr, Offset ptrIP, 4, AF_INET
					test eax,eax
					jz @F
					
					;------------------------------------------------
					; Get Fully Qualified Domain Name
					;------------------------------------------------
					mov ecx, [eax].hostent.h_name
					mov ptrIPName, ecx
					
					;------------------------------------------------
					; Get # IP Address
					;------------------------------------------------
					mov eax, [eax].hostent.h_list ; hostent.h_addr_list
					mov eax, [eax]  ;   *hostent.h_addr_list
					mov eax, [eax]  ;  **hostent.h_addr_list
					mov peer.sockaddr_in.sin_addr, eax
					
					;------------------------------------------------
					; Convert to a string
					;------------------------------------------------
					invoke inet_ntoa, eax
					
				;------------------------------------------------
				.endif
				;------------------------------------------------
				
				@@:
				.if eax==0
					invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("IP error")
					invoke closesocket,s
				.else
					invoke SendMessage,hStatusBar, SB_SETTEXT, 1,  eax
					invoke SendMessage,hStatusBar, SB_SETTEXT, 2,  ptrIPName
				.endif
				
		invoke KillTimer, hWin, IDT_TIMER1
					
	ret
GetHostDNSThread ENDP

ConnectIPThread PROC
				
			;-------------------------------------------
			; socket() -- Create i/o socket
			;-------------------------------------------
		
			invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("socket()")
			invoke socket,AF_INET, SOCK_STREAM, 0
			mov s, eax
			.if eax == INVALID_SOCKET
				invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("Socket Failed.")
				jmp SocketFailed
			.else
				invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("Socketed.")
			.endif
			

			;-------------------------------------------
			; connect() -- Wait for reply
			;-------------------------------------------
		
			invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("connect()")
			invoke connect, s, Offset peer, Sizeof peer
			test eax,eax
			.if !ZERO?
				invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("Failed to connect.")
			.else
				invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("Connected.")
			.endif
			
			SocketFailed:
					
			invoke KillTimer, hWin, IDT_TIMER1
					
	ret
ConnectIPThread ENDP

; ------------------------------------------------------------------------------------

IsWinNt proc
	LOCAL vi:OSVINFO		            ; Version Info Struct
	LOCAL pvi:DWORD			      ; Pointer To vi

	lea eax, vi                         ; vi's address into eax
	mov ecx, SizeOf vi                  ; sizeof vi struct into ecx
	mov (OSVINFO PTR [eax]).dwOSVersionInfoSize, ecx    ; copy size to element
	mov pvi, eax                        ; ptr to vi into pvi
	invoke GetVersionEx,pvi             ; get version API call
	cmp eax, 0                          ; See if we got an error
	je  IsWinNtError
    
	mov eax, pvi                        ; address back into eax
	mov ecx, (OSVINFO PTR [eax]).dwPlatformId  ; Platform ID into ecx
	cmp ecx, VER_PLATFORM_WIN32_NT      ; see if its an NT platform
	je  IsWinNtTrue

	mov eax, 0                          ; Return a Zero since its NOT NT
	ret
    
IsWinNtTrue:
	mov eax, 1                          ; Return 1 since it IS NT
	ret

IsWinNtError:
	mov eax, 2                          ; Return 2 indicating an Error
    
	ret

IsWinNt endp


AdjustToken proc prlgValue:dword
	LOCAL hdlProcessHandle:DWORD
	LOCAL hdlTokenHandle:DWORD
	LOCAL tmpLuid:LUIDCUST
	LOCAL tkp:TOKEN_PRIVS
	LOCAL tkpNewButIgnored:TOKEN_PRIVS
	LOCAL lBufferNeeded:DWORD
	LOCAL tBuff[32]:BYTE
	LOCAL ptBuff:DWORD

	invoke IsWinNt                 ; see if we're on an NT platform
	cmp eax, 1                     ; a return of 1 means NT platform.
	jne AdjTokDone

	invoke GetCurrentProcess       ; get the current process handle
	mov hdlProcessHandle,eax       ; save it to hdlProcessHandle

	lea eax, tBuff                 ; address of temp buffer into eax
	mov ptBuff, eax                ; set pointer to temp buffer
	mov BYTE PTR [eax], 0          ; initialize the buffer

	invoke OpenProcessToken,hdlProcessHandle,40,ADDR hdlTokenHandle
	invoke LookupPrivilegeValue,ptBuff,prlgValue,ADDR tmpLuid

	lea eax, tmpLuid               ; address of tmpLuid into eax

	; Contents of tmpLuid into ecx:edx
	mov ecx, (LUIDCUST PTR [eax]).usedpart
	mov edx, (LUIDCUST PTR [eax]).ignorehigh32bitpart
    
	lea eax, tkp                   ; address of tkp into eax
    
	mov (TOKEN_PRIVS PTR [eax]).privilegecount, 1
	mov (TOKEN_PRIVS PTR [eax]).theluid.usedpart, ecx
	mov (TOKEN_PRIVS PTR [eax]).theluid.ignorehigh32bitpart, edx
	mov (TOKEN_PRIVS PTR [eax]).attributes, 2

	invoke AdjustTokenPrivileges,hdlTokenHandle,0,ADDR tkp,SizeOf tkpNewButIgnored,ADDR tkpNewButIgnored,ADDR lBufferNeeded

AdjTokDone:

	ret

AdjustToken endp


SetTime PROC USES esi ebx TimeAddr:DWORD

   .if cSysTime.wYear != 0	
      invoke AdjustToken,addr szName      ; SADD("SE_SYSTEMTIME_NAME")

      invoke SystemTimeToFileTime,addr bSysTime,addr bfilTime
      invoke GetSystemTimeAsFileTime,addr dfilTime

      mov eax, dfilTime.dwLowDateTime
      mov edx, dfilTime.dwHighDateTime

      sub eax, bfilTime.dwLowDateTime       ; time elapsed between  recv and now
      sbb edx, bfilTime.dwHighDateTime

      add cfilTime.dwLowDateTime, eax
      adc cfilTime.dwHighDateTime, edx

      invoke FileTimeToSystemTime, addr cfilTime, addr cSysTime
      invoke SetLocalTime,addr cSysTime

 ;      .if eax==0
 ;         invoke HandleError,ADDR szCaption
 ;      .else
 ;         invoke MessageBox,hWnd,SADD("OK, Synchronized Your PC Time."),ADDR szCaption,MB_OK or MB_ICONINFORMATION
 ;      .endif

      .if eax != 0
         invoke MessageBox, 0, addr szTimeSet, addr szAppName, MB_OK
      .endif
   .endif

@exit:
      invoke ExitThread,NULL
	ret

SetTime ENDP

; ------------------------------------------------------------------------------------

SendDataThread PROC
				
				invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("send()")
				
				;-------------------------------------------
				; send() -- Send some data
				;-------------------------------------------
				invoke GetWindowText, hEditMyText, pBufferMyText, 4095
				invoke GetWindowTextLength, hEditMyText

					mov cSysTime.wYear, 0

					invoke send, s, pBufferMyText, eax, 0
					.if eax == SOCKET_ERROR
						invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("send error")
						jmp SockErr
					.else
						invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("Sent.")
					.endif
					invoke  GetSystemTime, addr aSysTime

					
				;-------------------------------------------
				; recv() -- Get data until we got enough
				;-------------------------------------------
				
					invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("recv()")
					mov  MessageSize, 4*4096
					push pBufferOutput
					pop  pBufferLoc
					@@:
						invoke recv, s,  pBuffer,  recvStringLength, 0    ; pBufferLoc
						test eax,eax
						jz Dun
						.if eax == SOCKET_ERROR
							invoke SendMessage,hStatusBar,  SB_SETTEXT, 0,  $String("recv error")
							; invoke SetWindowText, hEditOutput, $String("SOCKET_ERROR") 
							jmp SockErr
						.endif
                                    jmp Dun

						; add pBufferLoc, eax
						; sub MessageSize, eax
						; jnc @B

					Dun:
                                    invoke  GetSystemTime,addr bSysTime

                                    mov cSysTime.wYear,  2000   
                                    mov cSysTime.wMonth,    0  ;  4 1..12
                                    mov cSysTime.wDayOfWeek,0  ;  2 0..6
                                    mov cSysTime.wDay,      0  ; 17 1..31  28,29
                                    mov cSysTime.wHour,     0  ;  0 0..23
                                    mov cSysTime.wMinute,   0  ; 45 0..59
                                    mov cSysTime.wSecond,   0  ;  0 0..59
                                    mov cSysTime.wMilliseconds, 0

                                    mov ax, bSysTime.wMonth
                                    mov cSysTime.wMonth, ax

 ;                                     mov edx, esi
 ;                                     mov esi, pBufferOutput
 ;                                     
 ;                                     mov al, byte ptr szBuffer+37  ; year last two digits
 ;                                     mov byte ptr [esi + 0], al
 ;                                     mov al, byte ptr szBuffer+38
 ;                                     mov byte ptr [esi + 1], al
 ; 
 ;                                     mov al, byte ptr szBuffer+28  ; day  two digits
 ;                                     mov byte ptr [esi + 2], al
 ;                                     mov al, byte ptr szBuffer+29
 ;                                     mov byte ptr [esi + 3], al
 ; 
 ;                                     mov al, byte ptr szBuffer+40  ; hour two digits
 ;                                     mov byte ptr [esi + 4], al
 ;                                     mov al, byte ptr szBuffer+41
 ;                                     mov byte ptr [esi + 5], al
 ; 
 ;                                     mov al, byte ptr szBuffer+43  ; minute two digits
 ;                                     mov byte ptr [esi + 6], al
 ;                                     mov al, byte ptr szBuffer+44
 ;                                     mov byte ptr [esi + 7], al
 ; 
 ;                                     mov al, byte ptr szBuffer+46  ; seconds two digits
 ;                                     mov byte ptr [esi + 8], al
 ;                                     mov al, byte ptr szBuffer+47
 ;                                     mov byte ptr [esi + 9], al
 ; 
 ;                                     mov byte ptr [esi + 10], 0
 ; 
 ;                                     mov esi, edx

                                    mov ecx, 30   ; 30+18 = 48 "TMG "
                                    .if dword ptr [szBuffer+ecx+20] != "TMG "
                                        mov ecx, 0
                                        .repeat
                                           inc ecx
                                        .until dword ptr [szBuffer+ecx+20] == "TMG "
                                    .endif

                                    xor eax, eax
                                    mov ah, byte ptr [szBuffer+ 9+ecx]   ; year last two digits
                                    and ah, 15
                                    lea eax, [eax*4 + eax]
                                    add eax, eax
                                    mov al, byte ptr [szBuffer+10+ecx]
                                    and al, 15
                                    add al, ah
                                                   ; mov al, ah
                                    and ax, 255
                                    add cSysTime.wYear, ax

                                    xor eax, eax
                                    mov ah, byte ptr [szBuffer+ 0+ecx]  ; day  two digits
                                    and ah, 15
                                    lea eax, [eax*4 + eax]
                                    add eax, eax
                                    mov al, byte ptr [szBuffer+ 1+ecx]
                                    and al, 15
                                    add al, ah
                                    and ax, 255
                                    mov cSysTime.wDay, ax
                                    .if ax < bSysTime.wDay       ; new day 1 < 31 current
                                       inc cSysTime.wMonth       ; gets next month
                                       .if cSysTime.wMonth > 12  ; keep in range 1..12
                                          mov cSysTime.wMonth, 1
                                       .endif
                                    .endif

                                    xor eax, eax
                                    mov ah, byte ptr [szBuffer+12+ecx]  ; hour two digits
                                    and ah, 15
                                    lea eax, [eax*4 + eax]
                                    add eax, eax
                                    mov al, byte ptr [szBuffer+13+ecx]  ; 41
                                    and al, 15
                                    add al, ah
                                    and ax, 255
                                    mov cSysTime.wHour, ax

                                    xor eax, eax
                                    mov ah, byte ptr [szBuffer+15+ecx]  ; minute two digits
                                    and ah, 15
                                    lea eax, [eax*4 + eax]
                                    add eax, eax
                                    mov al, byte ptr [szBuffer+16+ecx]
                                    and al, 15
                                    add al, ah
                                    and ax, 255
                                    mov cSysTime.wMinute, ax

                                    xor eax, eax
                                    mov ah, byte ptr [szBuffer+18+ecx]  ; seconds two digits
                                    and ah, 15
                                    lea eax, [eax*4 + eax]
                                    add eax, eax
                                    mov al, byte ptr [szBuffer+19+ecx]
                                    and al, 15
                                    add al, ah
                                    and ax, 255
                                    mov cSysTime.wSecond, ax

                                    invoke SystemTimeToFileTime, addr cSysTime, addr cfilTime

                                    mov eax, loGMToffset
                                    mov edx, hiGMToffset
                                    .if GMToffset > 23
                                       sub cfilTime.dwLowDateTime,  eax      ; add if +GMT
                                       sbb cfilTime.dwHighDateTime, edx      ; adc if +GMT
                                    .else
                                       add cfilTime.dwLowDateTime,  eax      ; add if +GMT
                                       adc cfilTime.dwHighDateTime, edx      ; adc if +GMT
                                    .endif

                                    ; invoke FileTimeToSystemTime, addr cfilTime, addr cSysTime

                                    ;  Save input to a binary file
                                    ;
                                    ;  invoke CreateFile,ADDR szFNameOut,GENERIC_WRITE,
                                    ;                    FILE_SHARE_WRITE,NULL,CREATE_ALWAYS,
                                    ;                    FILE_ATTRIBUTE_NORMAL,NULL
                                    ;  mov hFileOut, eax
                                    ;  mov bWritten, 0
                                    ;  mov filelen,  92

                                    ;  invoke WriteFile,hFileOut,ADDR szBuffer,filelen,ADDR bWritten,NULL
                                    ;  invoke CloseHandle,hFileOut

                                    ; mov szBuffer+89, 13
                                    ; mov szBuffer+90, 10
                                    ; mov szBuffer+91, 0
                                    ; mov dword ptr szBuffer+92, 0
						invoke SetWindowText, hEditOutput, addr szBuffer    ; pBufferOutput
						invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("Received")
					SockErr:
					
			invoke KillTimer, hWin, IDT_TIMER1
					
	ret
SendDataThread ENDP

End Start